//+------------------------------------------------------------------+
//|                                          break-out-stops-exp.mq4 |
//|                Copyright  2006, Nick Bilak, beluck[AT]gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"
#property link      "http://www.mql4.info/"
#include <stdlib.mqh>

extern int myMagic = 1;

extern bool PartialTrades=false;
extern int TakeProfit1 = 100;
extern int TakeProfit2 = 30;
extern int StopLoss = 100;  
extern int TrailingStop = 0;  
extern int TrailingStep = 5;  
extern int BreakevenStop = 0;  
extern int BreakevenPips = 0;  
extern int TriggerPoint = 5;

extern string RangeStartTime="01:00";
extern string RangeEndTime="07:00";
extern string ExitTime="19:00";

extern int    slippage=2;   	//slippage for market order 

extern double Lots = 0.1;

extern int       OrderTriesNumber=5;
extern string EAName="breakout";

bool buysig,sellsig,closebuy,closesell; 
int lastsig,tries,buys,sells,long,short,co;
double h1,l1,spread;
int brstop;


//+------------------------------------------------------------------+
//| Calculate open positions                                         |
//+------------------------------------------------------------------+
int CalculateCurrentOrders() {
   int ord;
//----
   long=0; short=0;
   for(int i=0;i<OrdersTotal();i++)  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==myMagic)  {
         ord++;
         if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP)  long++;
         if(OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) short++;
      }
   }
//---- return orders volume
   return(ord);
}


void CheckForOpen() {
   int    res,tr;
   double entry,stop,profit,mins=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
   

   if (TimeCurrent()>=StrToTime(ExitTime)) {
      CheckForClose();
      return;
   }

   if (TimeCurrent()<StrToTime(RangeEndTime)) return;

   co=CalculateCurrentOrders();
   if (co>0) return;

   if (lastsig!=Time[0]) {
      GetRange();
      lastsig=Time[0];
   }

   if (Bid<h1+spread+TriggerPoint*Point-mins && long==0)  {
      if (!PartialTrades)
         res=OpenOrder(OP_BUYSTOP,Lots,h1+spread+TriggerPoint*Point,StopLoss,TakeProfit1);
      else {
         res=OpenOrder(OP_BUYSTOP,Lots,h1+spread+TriggerPoint*Point,StopLoss,TakeProfit1);
         res=OpenOrder(OP_BUYSTOP,Lots,h1+spread+TriggerPoint*Point,StopLoss,TakeProfit2);
      }
   }
   if (Bid>l1-TriggerPoint*Point+mins && short==0)  {
      if (!PartialTrades)
         res=OpenOrder(OP_SELLSTOP,Lots,l1-TriggerPoint*Point,StopLoss,TakeProfit1);
      else {
         res=OpenOrder(OP_SELLSTOP,Lots,l1-TriggerPoint*Point,StopLoss,TakeProfit1);
         res=OpenOrder(OP_SELLSTOP,Lots,l1-TriggerPoint*Point,StopLoss,TakeProfit2);
      }
   }
}
  
int OpenOrder(int mode,double lot, double opr, int SL, int TP) {
   int    res,tr,col;
   double openprice,sl,tp;
   tries=0;
   while (res<=0 && tries<OrderTriesNumber) {
      tr=0; while (tr<5 && !IsTradeAllowed()) { tr++; Sleep(2000); }
      RefreshRates();
      if (mode==OP_SELLSTOP) {
         openprice=opr; 
         if (SL>0) sl=openprice+SL*Point;
         if (TP>0) tp=openprice-TP*Point;
         col=Red;
      } else
      if (mode==OP_BUYSTOP) {
         openprice=opr;
         if (SL>0) sl=openprice-SL*Point;
         if (TP>0) tp=openprice+TP*Point;
         col=Blue;
      } else return;
      Print(Symbol(),"  ",mode,"  ",lot,"  ",openprice,"  ",sl,"  ",tp,"  ");
      res=OrderSend(Symbol(),mode,lot,openprice,slippage,sl,tp,EAName+"_"+myMagic,myMagic,0,col);
      tries++;
   }
   if (res<=0) Print("Error opening order : ",ErrorDescription(GetLastError()));
   return(res);
}
  
//+------------------------------------------------------------------+
//| Check for close order conditions                                 |
//+------------------------------------------------------------------+
void CheckForClose()  {
   bool bres; int tr;
   for(int i=OrdersTotal()-1;i>=0;i--) {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES))  continue;
      if(OrderMagicNumber()!=myMagic || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY || OrderType()==OP_SELL)   {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while(tr<6 && !IsTradeAllowed()) { tr++; Sleep(2000); }
               RefreshRates();
               bres=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,White);
			      if (!bres) Print("Error closing order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
      } else {
            bres=false;
	         tries=0;
		      while (!bres && tries<OrderTriesNumber) {
               tr=0; while(tr<6 && !IsTradeAllowed()) { tr++; Sleep(2000); }
               RefreshRates();
               bres=OrderDelete(OrderTicket());
			      if (!bres) Print("Error deleting order : ",ErrorDescription(GetLastError()));
			      tries++;
			   }
      }
   }
}


void TrailStop() {
   bool bres;
   double StopLoss;
   if ( TrailingStop > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Ask < OrderOpenPrice()+TrailingStop*Point )  continue;
            StopLoss = Ask-TrailingStop*Point;
            if ( StopLoss-OrderStopLoss() < TrailingStep*Point )  continue;
            if (OrderStopLoss()>=OrderOpenPrice()) StopLoss=OrderStopLoss()+TrailingStep*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Bid > OrderOpenPrice()-TrailingStop*Point )  continue;
            StopLoss = Bid+TrailingStop*Point;
            if ( OrderStopLoss()>0 && OrderStopLoss()-StopLoss < TrailingStep*Point )  continue;
            if ( OrderStopLoss()>0 && OrderStopLoss()<=OrderOpenPrice()) StopLoss=OrderStopLoss()-TrailingStep*Point;
            if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

void start()  {

//---- check for history and trading
   if(Bars<100 || IsTradeAllowed()==false) return;

   spread=Ask-Bid;

   brstop=MarketInfo(Symbol(),MODE_STOPLEVEL)+1;

   CheckForOpen();

   BreakEvenStop(BreakevenStop,BreakevenPips);
   
   TrailStop();
}

void GetRange() {
   int rs=iBarShift(Symbol(),PERIOD_H1,StrToTime(RangeStartTime),true);
   int re=iBarShift(Symbol(),PERIOD_H1,StrToTime(RangeEndTime)-60*60,true);
   if (rs<0 || re<0) return;
   h1=iHigh(NULL,PERIOD_H1,iHighest(NULL,PERIOD_H1,MODE_HIGH,rs-re+1,re));
   l1=iLow(NULL,PERIOD_H1,iLowest(NULL,PERIOD_H1,MODE_LOW,rs-re+1,re));
}


void BreakEvenStop(int BES, int BELP) {
   bool bres;
   double StopLoss;
   if ( BES > 2 ) {
      for (int i = 0; i < OrdersTotal(); i++) {
         if ( OrderSelect (i, SELECT_BY_POS) == false )  continue;
         if ( OrderSymbol() != Symbol() || OrderMagicNumber() != myMagic )  continue;
         if ( OrderType() == OP_BUY ) {
            if ( Bid < OrderOpenPrice()+BES*Point )  continue;
            StopLoss = OrderOpenPrice()+BELP*Point;
            if ( StopLoss > OrderStopLoss() ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, White);
					   if (!bres) Print("Error Modifying BUY order : ",ErrorDescription(GetLastError()));
            }
         }
   
         if ( OrderType() == OP_SELL ) {
            if ( Ask > OrderOpenPrice()-BES*Point )  continue;
            StopLoss = OrderOpenPrice()-BELP*Point;
            if ( StopLoss < OrderStopLoss() || OrderStopLoss()<Point ) {
                  bres=OrderModify (OrderTicket(), OrderOpenPrice(), StopLoss, OrderTakeProfit(), 0, Gold);
					   if (!bres) Print("Error Modifying SELL order : ",ErrorDescription(GetLastError()));
            }
         }
      }
   }
   return;
}

